CON
  _CLKMODE      = XTAL1 + PLL16X                        
  _XINFREQ      = 5_000_000

  MULUL   = %000100_001         ' instruction bits for MUL / MULS
  MULUH   = %000100_011
  MULSL   = %000101_001
  MULSH   = %000101_011

OBJ
  LCD : "LCD_16X2_8BIT"
  
VAR

  long  cog
  
  long  mulinstr
  long  param1
  long  param2
  long  product

PUB TESTMUL

  LCD.START
  
  start

  showmul($FFFFFFFF, -1)

'  WAITCNT(240_000_000 + CNT)

  stop


pub start
  stop
  cog := cognew(@entry, @mulinstr) + 1
  return (cog > 0)


pub stop
  if cog
    cogstop(cog~ - 1)

pub showmul(value1, value2)
  ' unsigned on line
  domul(MULUH, value1, value2)
  LCD.MOVE(1,1)
  LCD.HEX (product,8)
  domul(MULUL, value1, value2)
  LCD.HEX (product,8)
  ' signed on line 2
  domul(MULSH, value1, value2)
  LCD.MOVE(1,2)
  LCD.HEX (product,8)
  domul(MULSL, value1, value2)
  LCD.HEX (product,8)


pub domul(minstr, value1, value2)
  longmove(@param1, @value1, 2)                                 ' copy parameters
  mulinstr := minstr                                            ' set the instruction
  repeat while mulinstr                                         ' wait for result
  return product                                                ' return to caller


dat

                        org     0
entry                  
                        mov     hptr, par                       ' get address of args in hub
                        rdlong  instr, hptr             wz      ' wait for instr from spin
        if_z            jmp     #entry
                                                                ' prepare the mul instruction
                        movi    muli, instr                     ' *** BEWARE: NOT VALIDATED! ***
                        movd    muli, #val1                     ' multiplicand reg
                        movs    muli, #val2                     ' multiplier reg
                        
                        add     hptr, #4
                        rdlong  val1, hptr                      ' get multiplicand from hub
                        add     hptr, #4
                        rdlong  val2, hptr                      ' get multiplier from hub

muli                  ' long    %00010s_ZpRICCCC_DDDDDDDDD_SSSSSSSSS
                        long    %000100_10101111_000000000_000000000

                        add     hptr, #4                        ' point to result in hub
                        wrlong  val1, hptr                      ' write result to hub                   

                        mov     instr, #0                       ' clear instr
                        wrlong  instr, par                      ' flag 'done' to spin
                        
                        jmp     #entry                          ' wait for next instr


hptr                    res     1
                                                                
instr                   res     1
val1                    res     1
val2                    res     1      

                        fit     492